<app-loading *ngIf="isLoading"></app-loading>
<div class='app-card'>
  <form nz-form [formGroup]='form'>
    <!--Button-->
    <div nz-row [nzGutter]='[30,0]' class='btn-fixed-right'>
      <div nz-col [nzXs]='24' [nzLg]='24' [ngStyle]="{'text-align': 'right'}">
        <mb-button
          mbButtonSize='SMALL'
          mbButtonAvailableStyle='PRIMARY'
          (click)='onSave()'
          mbButtonText="{{'common.button.save' | translate}}"
        ></mb-button>

      </div>
    </div>
    <!--End: Button-->
    <div nz-row [nzGutter]='[30,10]'>
      <div nz-col [nzLg]='12' [nzXs]='12'>
        <mb-input-text formControlName='rrcCode' [mbMaxLength]='50' uppercase (mbBlur)='codeBlur()' [mbDisable]='id != null'
                       [mbType]="isSubmitted && form.controls['rrcCode'].errors ? 'error' : 'default'"
                       [mbShowError]="isSubmitted && form.controls['rrcCode'].errors !== null"
                       [mbErrors]="form.controls['rrcCode'].errors"
                       [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'reports.validate.maxLength' | translate: {'numberLength': '50' }},
           { errorName: 'code', errorDescription: 'reports.validate.code' | translate },
           { errorName: 'required', errorDescription: 'reports.validate.required' | translate: {'param': 'reports.reportCategory.rrcCode' | translate }}]"
                       mbPlaceholderText="{{'reports.reportCategory.rrcCode' | translate}}"
                       mbLabelText="{{'reports.reportCategory.rrcCode' | translate}} <span class='label__required'>*</span>"></mb-input-text>
      </div>
      <div nz-col [nzLg]='12' [nzXs]='12'>
        <mb-input-text
          formControlName='rrcName' [mbMaxLength]="200"
          [mbType]="isSubmitted && form.controls['rrcName'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && form.controls['rrcName'].errors != null"
          [mbErrors]="form.controls['rrcName'].errors"
          [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'reports.validate.required' | translate: {'param': 'reports.reportCategory.rrcName' | translate }}]"
          mbLabelText="{{'reports.reportCategory.rrcName' | translate}} <span class='label__required'>*</span>"
          mbPlaceholderText="{{'reports.reportCategory.rrcName' | translate}}">
        </mb-input-text>
      </div>
      <div nz-col [nzLg]='12' [nzXs]='12'>
        <mb-select
          [mbDataSelects]='listReportGroup'
          mbKeyLabel='rrgName'
          mbKeyValue='id'
          [mbType]="isSubmitted && form.controls['flagStatus'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && form.controls['flagStatus'].errors != null"
          [mbErrors]="form.controls['flagStatus'].errors"
          [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'reports.validate.required' | translate: {'param': 'reports.reportCategory.rrgId' | translate }}]"
          mbLabelText="{{'reports.reportCategory.rrgId' | translate}} <span class='label__required'>*</span>"
          mbPlaceholder="{{'reports.reportCategory.rrgId' | translate}}"
          formControlName='rrg'></mb-select>
      </div>

      <div nz-col [nzLg]='12' [nzXs]='12'>
        <mb-input-text (mbChange)='changeReportPath()'
          formControlName='reportPath' [mbMaxLength]="150" [isSpecial]='true'
          [mbType]="isSubmitted && form.controls['reportPath'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && form.controls['reportPath'].errors != null"
          [mbErrors]="form.controls['reportPath'].errors"
          [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'reports.validate.required' | translate: {'param': 'reports.reportCategory.reportPath' | translate }}]"
          mbLabelText="{{'reports.reportCategory.reportPath' | translate}} <span class='label__required'>*</span>"
          mbPlaceholderText="{{'reports.reportCategory.reportPath' | translate}}">
        </mb-input-text>
      </div>

      <div nz-col [nzLg]='12' [nzXs]='12'>
        <mb-select
          [mbDataSelects]='listStatus'
          mbKeyLabel='label'
          mbKeyValue='value'
          [mbType]="isSubmitted && form.controls['flagStatus'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && form.controls['flagStatus'].errors != null"
          [mbErrors]="form.controls['flagStatus'].errors"
          [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'reports.validate.required' | translate: {'param': 'reports.reportCategory.flagStatus' | translate }}]"
          mbLabelText="{{'reports.reportCategory.flagStatus' | translate}} <span class='label__required'>*</span>"
          mbPlaceholder="{{'reports.reportCategory.flagStatus' | translate}}"
          formControlName='flagStatus'></mb-select>
      </div>
    </div>
    <div nz-row class='label__divider--wrap'>
      <div nz-col [nzXs]='21' [nzLg]='21' class='input__group'>
        <label
          class='label__divider'>{{'reports.reportCategory.rrcpInfo' | translate}}</label>
      </div>
      <div nz-col [nzXs]='3' [nzLg]='3' class='input__group align-right'>
        <mb-button
          mbButtonSize='SMALL'
          mbButtonAvailableStyle='PRIMARY'
          (click)='getListParamBI()'
          mbButtonText="{{'reports.reportCategory.getRrpcBI' | translate}}"
        ></mb-button>
      </div>
    </div>
    <nz-divider class='hrTag'></nz-divider>
    <div nz-row [nzGutter]='[30,30]'>
      <ng-container formArrayName='rptRrcParamDTOList'>
        <nz-table nz-col nzXs='24' nzLg='24' [nzData]='form.controls["rptRrcParamDTOList"].value' nzSize='small'
                  [nzShowPagination]='false' [nzPageSize]='form.controls["rptRrcParamDTOList"].value.length'>
          <thead>
          <tr>
            <th nzWidth='5%' class='align-center'>STT</th>
            <th nzWidth='15%'>{{'reports.reportCategory.rrcpCode' | translate}}</th>
            <th nzWidth='15%'>{{'reports.reportCategory.rrcpName' | translate}}</th>
            <th nzWidth='15%'>{{'reports.reportCategory.rrcpType' | translate}}</th>
            <th nzWidth='10%' class='align-center'>{{'reports.reportCategory.isRequired' | translate}}</th>
            <th nzWidth='10%' class='align-center'>{{'reports.reportCategory.isShow' | translate}}</th>
            <th nzWidth='15%'>{{'reports.reportCategory.biDataType' | translate}}</th>
            <th nzWidth='25%'>{{'reports.reportCategory.queryData' | translate}}</th>
          </tr>
          </thead>
          <tbody>
          <tr *ngFor='let data of rptRrcParamDTOList?.controls; let i = index; let first = first' [formGroupName]='i'>
            <td [ngStyle]='{"max-width": "5%"}' class='align-center'>
              {{ i + 1 }}
            </td>
            <td [ngStyle]='{"max-width": "15%"}'>
              {{data.controls['rrcpCode']?.value}}
            </td>
            <td [ngStyle]='{"max-width": "15%"}'>
              <mb-input-text
                formControlName='rrcpName' [mbMaxLength]="200"
                [mbType]="isSubmitted && data.controls['rrcpName']?.errors ? 'error' : 'default'"
                [mbShowError]="isSubmitted && data.controls['rrcpName']?.errors != null"
                [mbErrors]="data.controls['rrcpName']?.errors"
                [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'reports.validate.required' | translate: {'param': 'reports.reportCategory.rrcpName' | translate }}]"
                mbPlaceholderText="{{'reports.reportCategory.rrcpName' | translate}}">
              </mb-input-text>
            </td>
            <td [ngStyle]='{"max-width": "15%"}'>
              <mb-select
                [mbDataSelects]='listParamType'
                mbKeyLabel='label'
                mbKeyValue='value'
                [mbType]="isSubmitted && data.controls['rrcpType']?.errors ? 'error' : 'default'"
                [mbShowError]="isSubmitted && data.controls['rrcpType']?.errors != null"
                [mbErrors]="data.controls['rrcpType']?.errors"
                [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'reports.validate.required' | translate: {'param': 'reports.reportCategory.rrcpType' | translate }}]"
                mbPlaceholder="{{'reports.reportCategory.rrcpType' | translate}}"
                (mbEventEmit)='changeDataType(data)'
                formControlName='rrcpType'></mb-select>
            </td>
            <td [ngStyle]='{"max-width": "10%"}' class='align-center'>
              <label
                nz-checkbox
                class='check__contract-proposal'
                formControlName='isRequired'
              ></label>
            </td>
            <td [ngStyle]='{"max-width": "10%"}' class='align-center'>
              <label
                nz-checkbox
                class='check__contract-proposal'
                formControlName='isShow'
              ></label>
            </td>
            <td [ngStyle]='{"max-width": "15%"}'>
              <mb-select
                [mbDataSelects]='listDataTypeInBI'
                [mbDisable]='true'
                mbKeyLabel='label'
                mbKeyValue='value'
                [mbType]="isSubmitted && data.controls['biDataType']?.errors ? 'error' : 'default'"
                [mbShowError]="isSubmitted && data.controls['biDataType']?.errors != null"
                [mbErrors]="data.controls['biDataType']?.errors"
                [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'reports.validate.required' | translate: {'param': 'reports.reportCategory.biDataType' | translate }}]"
                mbPlaceholder="{{'reports.reportCategory.biDataType' | translate}}"
                formControlName='biDataType'></mb-select>
            </td>
            <td [ngStyle]='{"max-width": "25%"}'>
              <mb-input-text
                formControlName='queryData' [mbIsTextAre]='true' [mbIsTextAreInputSpecial]='true'
                [mbType]="isSubmitted && data.controls['queryData']?.errors ? 'error' : 'default'"
                [mbShowError]="isSubmitted && data.controls['queryData']?.errors != null"
                [mbErrors]="data.controls['queryData']?.errors"
                [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'reports.validate.required' | translate: {'param': 'reports.reportCategory.queryData' | translate }}]"
                mbPlaceholderText="{{'reports.reportCategory.queryData' | translate}}">
              </mb-input-text>
            </td>
          </tr>
          </tbody>
        </nz-table>
      </ng-container>
    </div>
  </form>
</div>

